!config
# Arara, the cool TeX automation tool
# Copyright (c) 2020, Island of TeX
# All rights reserved.
#
# This rule is part of arara.
identifier: ptex
name: pTeX
authors:
- Island of TeX
commands:
- name: pTeX engine
  command: >
    @{
        return getCommand('ptex', interaction, shell,
               synctex, options, reference.getName());
    }
arguments:
- identifier: interaction
  flag: >
    @{
        if ([ 'batchmode', 'nonstopmode', 'scrollmode',
              'errorstopmode' ].contains(parameters.interaction)) {
            return '--interaction='.concat(parameters.interaction);
        }
        else {
            throwError('The provided interaction value is not valid.');
        }
    }
- identifier: shell
  flag: >
    @{
        isTrue(parameters.shell, '--shell-escape', '--no-shell-escape')
    }
- identifier: synctex
  flag: >
    @{
        isTrue(parameters.synctex, '--synctex=1', '--synctex=0')
    }
- identifier: options
  flag: >
    @{
        if (isList(parameters.options)) {
            return parameters.options;
        }
        else {
            throwError('I was expecting a list of options.');
        }
    }
